-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Filter Builder - With Data Grid
This demo shows how to use a standalone JavaScript FilterBuilder to filter data in the DataGrid component. The DataGrid also has an integrated filter builder that can be invoked using the filter panel (see the Filter Panel demo).
DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the FilterBuilder features used.
Backend API
$(() => {
$('#filterBuilder').dxFilterBuilder({
fields,
value: filter,
});
$('#apply').dxButton({
text: 'Apply Filter',
type: 'default',
onClick() {
const filter = $('#filterBuilder').dxFilterBuilder('instance').option('value');
$('#dataGrid').dxDataGrid('instance').option('filterValue', filter);
},
});
$('#dataGrid').dxDataGrid({
columns,
showBorders: true,
dataSource: products,
filterValue: filter,
height: 300,
});
});
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script src="js/dx.all.js?v=25.2.7"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="data.js"></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="filter-container">
<div id="filterBuilder"></div>
<div id="apply"></div>
<div class="dx-clearfix"></div>
</div>
<div id="dataGrid"></div>
</div>
</body>
</html>
.filter-container {
background-color: transparent;
box-shadow: 0 8px 16px 0 rgba(0, 0, 0, 0.14), 0 0 2px 0 rgba(0, 0, 0, 0.12);
border-radius: 6px;
padding: 5px;
width: 500px;
margin: 24px;
}
.dx-filterbuilder {
background-color: transparent;
padding: 10px;
}
.dx-button {
margin: 10px;
float: right;
}
.dx-filterbuilder .dx-numberbox {
width: 80px;
}
const filter = [
['Product_Current_Inventory', '<>', 0],
'or',
[
['Product_Name', 'contains', 'HD'],
'and',
['Product_Cost', '<', 200],
],
];
const fields = [
{
caption: 'ID',
dataField: 'Product_ID',
dataType: 'number',
}, {
dataField: 'Product_Name',
dataType: 'string',
}, {
caption: 'Cost',
dataField: 'Product_Cost',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Sale_Price',
caption: 'Sale Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Retail_Price',
caption: 'Retail Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Current_Inventory',
dataType: 'number',
caption: 'Inventory',
},
];
const columns = [
{
caption: 'ID',
dataField: 'Product_ID',
dataType: 'number',
width: 50,
}, {
dataField: 'Product_Name',
dataType: 'string',
}, {
caption: 'Cost',
dataField: 'Product_Cost',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Sale_Price',
caption: 'Sale Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Retail_Price',
caption: 'Retail Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Current_Inventory',
dataType: 'number',
caption: 'Inventory',
},
];
const products = [
{
Product_ID: 1,
Product_Name: "HD Video Player",
Product_Cost: "110.0000",
Product_Sale_Price: "220.0000",
Product_Retail_Price: "330.0000",
Product_Current_Inventory: 225,
},
{
Product_ID: 2,
Product_Name: "SuperHD Video Player",
Product_Cost: "175.0000",
Product_Sale_Price: "275.0000",
Product_Retail_Price: "400.0000",
Product_Current_Inventory: 150,
},
{
Product_ID: 3,
Product_Name: "SuperPlasma 50",
Product_Cost: "1100.0000",
Product_Sale_Price: "1800.0000",
Product_Retail_Price: "2400.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 4,
Product_Name: "SuperLED 50",
Product_Cost: "775.0000",
Product_Sale_Price: "1100.0000",
Product_Retail_Price: "1600.0000",
Product_Current_Inventory: 77,
},
{
Product_ID: 5,
Product_Name: "SuperLED 42",
Product_Cost: "675.0000",
Product_Sale_Price: "1050.0000",
Product_Retail_Price: "1450.0000",
Product_Current_Inventory: 445,
},
{
Product_ID: 6,
Product_Name: "SuperLCD 55",
Product_Cost: "745.0000",
Product_Sale_Price: "1045.0000",
Product_Retail_Price: "1350.0000",
Product_Current_Inventory: 345,
},
{
Product_ID: 7,
Product_Name: "SuperLCD 42",
Product_Cost: "710.0000",
Product_Sale_Price: "999.0000",
Product_Retail_Price: "1200.0000",
Product_Current_Inventory: 210,
},
{
Product_ID: 8,
Product_Name: "SuperPlasma 65",
Product_Cost: "1800.0000",
Product_Sale_Price: "2900.0000",
Product_Retail_Price: "3500.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 9,
Product_Name: "SuperLCD 70",
Product_Cost: "2125.0000",
Product_Sale_Price: "3200.0000",
Product_Retail_Price: "4000.0000",
Product_Current_Inventory: 95,
},
{
Product_ID: 10,
Product_Name: "DesktopLED 21",
Product_Cost: "75.0000",
Product_Sale_Price: "125.0000",
Product_Retail_Price: "175.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 11,
Product_Name: "DesktopLED 19",
Product_Cost: "70.0000",
Product_Sale_Price: "115.0000",
Product_Retail_Price: "165.0000",
Product_Current_Inventory: 425,
},
{
Product_ID: 12,
Product_Name: "DesktopLCD 21",
Product_Cost: "75.0000",
Product_Sale_Price: "120.0000",
Product_Retail_Price: "170.0000",
Product_Current_Inventory: 210,
},
{
Product_ID: 13,
Product_Name: "DesktopLCD 19",
Product_Cost: "68.0000",
Product_Sale_Price: "110.0000",
Product_Retail_Price: "160.0000",
Product_Current_Inventory: 150,
},
{
Product_ID: 14,
Product_Name: "Projector Plus",
Product_Cost: "225.0000",
Product_Sale_Price: "400.0000",
Product_Retail_Price: "550.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 15,
Product_Name: "Projector PlusHD",
Product_Cost: "425.0000",
Product_Sale_Price: "600.0000",
Product_Retail_Price: "750.0000",
Product_Current_Inventory: 110,
},
{
Product_ID: 16,
Product_Name: "Projector PlusHT",
Product_Cost: "725.0000",
Product_Sale_Price: "900.0000",
Product_Retail_Price: "1050.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 17,
Product_Name: "ExcelRemote IR",
Product_Cost: "55.0000",
Product_Sale_Price: "105.0000",
Product_Retail_Price: "150.0000",
Product_Current_Inventory: 650,
},
{
Product_ID: 18,
Product_Name: "ExcelRemote Bluetooth",
Product_Cost: "85.0000",
Product_Sale_Price: "135.0000",
Product_Retail_Price: "180.0000",
Product_Current_Inventory: 310,
},
{
Product_ID: 19,
Product_Name: "ExcelRemote IP",
Product_Cost: "105.0000",
Product_Sale_Price: "155.0000",
Product_Retail_Price: "200.0000",
Product_Current_Inventory: 0,
},
];

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the FilterBuilder features used.
Backend API
<div class="filter-container">
<dx-filter-builder [fields]="fields" [(value)]="filter"> </dx-filter-builder>
<dx-button text="Apply Filter" type="default" (onClick)="buttonClick()">
</dx-button>
<div class="dx-clearfix"></div>
</div>
<dx-data-grid
[dataSource]="dataSource"
[filterValue]="gridFilterValue"
[showBorders]="true"
[columns]="columns"
[height]="300"
>
</dx-data-grid>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import {
DxDataGridModule,
DxButtonModule,
DxFilterBuilderModule,
} from 'devextreme-angular';
import { Service } from './app.service';
import type { Fields, Columns, Condition, Product } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxDataGridModule,
DxButtonModule,
DxFilterBuilderModule,
],
})
export class AppComponent {
dataSource: Product[];
fields: Fields;
columns: Columns;
filter: Condition;
gridFilterValue: Condition;
constructor(service: Service) {
this.fields = service.getFields();
this.columns = service.getColumns();
this.filter = service.getFilter();
this.gridFilterValue = this.filter;
this.dataSource = service.getProducts();
}
buttonClick() {
this.gridFilterValue = this.filter;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .filter-container {
background-color: transparent;
box-shadow: 0 8px 16px 0 rgba(0, 0, 0, 0.14), 0 0 2px 0 rgba(0, 0, 0, 0.12);
border-radius: 6px;
padding: 5px;
width: 500px;
margin: 24px;
}
::ng-deep .dx-filterbuilder {
background-color: transparent;
padding: 10px;
}
::ng-deep .dx-button {
margin: 10px;
float: right;
}
::ng-deep .dx-filterbuilder .dx-numberbox {
width: 80px;
}
import { Injectable } from '@angular/core';
export type Condition = Condition[] | string | number;
export type Fields = typeof fields;
export type Columns = typeof columns;
export interface Product {
Product_ID: number;
Product_Name: string;
Product_Cost: string;
Product_Sale_Price: string;
Product_Retail_Price: string;
Product_Current_Inventory: number;
}
const filter: Condition = [
['Product_Current_Inventory', '<>', 0],
'or',
[
['Product_Name', 'contains', 'HD'],
'and',
['Product_Cost', '<', 200],
],
];
const fields: Record<string, string>[] = [
{
caption: 'ID',
dataField: 'Product_ID',
dataType: 'number',
}, {
dataField: 'Product_Name',
dataType: 'string',
}, {
caption: 'Cost',
dataField: 'Product_Cost',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Sale_Price',
caption: 'Sale Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Retail_Price',
caption: 'Retail Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Current_Inventory',
dataType: 'number',
caption: 'Inventory',
},
];
const columns: Record<string, string | number>[] = [
{
caption: 'ID',
dataField: 'Product_ID',
dataType: 'number',
width: 50,
}, {
dataField: 'Product_Name',
dataType: 'string',
}, {
caption: 'Cost',
dataField: 'Product_Cost',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Sale_Price',
caption: 'Sale Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Retail_Price',
caption: 'Retail Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Current_Inventory',
dataType: 'number',
caption: 'Inventory',
},
];
const products: Product[] = [
{
Product_ID: 1,
Product_Name: "HD Video Player",
Product_Cost: "110.0000",
Product_Sale_Price: "220.0000",
Product_Retail_Price: "330.0000",
Product_Current_Inventory: 225,
},
{
Product_ID: 2,
Product_Name: "SuperHD Video Player",
Product_Cost: "175.0000",
Product_Sale_Price: "275.0000",
Product_Retail_Price: "400.0000",
Product_Current_Inventory: 150,
},
{
Product_ID: 3,
Product_Name: "SuperPlasma 50",
Product_Cost: "1100.0000",
Product_Sale_Price: "1800.0000",
Product_Retail_Price: "2400.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 4,
Product_Name: "SuperLED 50",
Product_Cost: "775.0000",
Product_Sale_Price: "1100.0000",
Product_Retail_Price: "1600.0000",
Product_Current_Inventory: 77,
},
{
Product_ID: 5,
Product_Name: "SuperLED 42",
Product_Cost: "675.0000",
Product_Sale_Price: "1050.0000",
Product_Retail_Price: "1450.0000",
Product_Current_Inventory: 445,
},
{
Product_ID: 6,
Product_Name: "SuperLCD 55",
Product_Cost: "745.0000",
Product_Sale_Price: "1045.0000",
Product_Retail_Price: "1350.0000",
Product_Current_Inventory: 345,
},
{
Product_ID: 7,
Product_Name: "SuperLCD 42",
Product_Cost: "710.0000",
Product_Sale_Price: "999.0000",
Product_Retail_Price: "1200.0000",
Product_Current_Inventory: 210,
},
{
Product_ID: 8,
Product_Name: "SuperPlasma 65",
Product_Cost: "1800.0000",
Product_Sale_Price: "2900.0000",
Product_Retail_Price: "3500.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 9,
Product_Name: "SuperLCD 70",
Product_Cost: "2125.0000",
Product_Sale_Price: "3200.0000",
Product_Retail_Price: "4000.0000",
Product_Current_Inventory: 95,
},
{
Product_ID: 10,
Product_Name: "DesktopLED 21",
Product_Cost: "75.0000",
Product_Sale_Price: "125.0000",
Product_Retail_Price: "175.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 11,
Product_Name: "DesktopLED 19",
Product_Cost: "70.0000",
Product_Sale_Price: "115.0000",
Product_Retail_Price: "165.0000",
Product_Current_Inventory: 425,
},
{
Product_ID: 12,
Product_Name: "DesktopLCD 21",
Product_Cost: "75.0000",
Product_Sale_Price: "120.0000",
Product_Retail_Price: "170.0000",
Product_Current_Inventory: 210,
},
{
Product_ID: 13,
Product_Name: "DesktopLCD 19",
Product_Cost: "68.0000",
Product_Sale_Price: "110.0000",
Product_Retail_Price: "160.0000",
Product_Current_Inventory: 150,
},
{
Product_ID: 14,
Product_Name: "Projector Plus",
Product_Cost: "225.0000",
Product_Sale_Price: "400.0000",
Product_Retail_Price: "550.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 15,
Product_Name: "Projector PlusHD",
Product_Cost: "425.0000",
Product_Sale_Price: "600.0000",
Product_Retail_Price: "750.0000",
Product_Current_Inventory: 110,
},
{
Product_ID: 16,
Product_Name: "Projector PlusHT",
Product_Cost: "725.0000",
Product_Sale_Price: "900.0000",
Product_Retail_Price: "1050.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 17,
Product_Name: "ExcelRemote IR",
Product_Cost: "55.0000",
Product_Sale_Price: "105.0000",
Product_Retail_Price: "150.0000",
Product_Current_Inventory: 650,
},
{
Product_ID: 18,
Product_Name: "ExcelRemote Bluetooth",
Product_Cost: "85.0000",
Product_Sale_Price: "135.0000",
Product_Retail_Price: "180.0000",
Product_Current_Inventory: 310,
},
{
Product_ID: 19,
Product_Name: "ExcelRemote IP",
Product_Cost: "105.0000",
Product_Sale_Price: "155.0000",
Product_Retail_Price: "200.0000",
Product_Current_Inventory: 0,
},
];
@Injectable()
export class Service {
getColumns(): Columns {
return columns;
}
getFields(): Fields {
return fields;
}
getFilter(): Condition {
return filter;
}
getProducts(): Product[] {
return products;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.68/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.8"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the FilterBuilder features used.
Backend API
<template>
<div>
<div class="filter-container">
<DxFilterBuilder
:fields="fields"
v-model:value="filterValue"
/>
<DxButton
text="Apply Filter"
type="default"
@click="buttonClick()"
/>
<div class="dx-clearfix"/>
</div>
<DxDataGrid
:data-source="products"
:filter-value="gridFilterValue"
:show-borders="true"
:columns="columns"
:height="300"
/>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxFilterBuilder from 'devextreme-vue/filter-builder';
import DxButton from 'devextreme-vue/button';
import DxDataGrid from 'devextreme-vue/data-grid';
import { filter, fields, columns, products } from './data.ts';
const filterValue = ref(filter);
const gridFilterValue = ref(filter);
function buttonClick() {
gridFilterValue.value = filterValue.value;
}
</script>
<style scoped>
.filter-container {
background-color: transparent;
box-shadow: 0 8px 16px 0 rgba(0, 0, 0, 0.14), 0 0 2px 0 rgba(0, 0, 0, 0.12);
border-radius: 6px;
padding: 5px;
width: 500px;
margin: 24px;
}
.dx-filterbuilder {
background-color: transparent;
padding: 10px;
}
.dx-button {
margin: 10px;
float: right;
}
.dx-filterbuilder .dx-numberbox {
width: 80px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import { type DxDataGridTypes } from 'devextreme-vue/data-grid';
import { type DxFilterBuilderTypes } from 'devextreme-vue/filter-builder';
interface Product {
Product_ID: number;
Product_Name: string;
Product_Cost: string;
Product_Sale_Price: string;
Product_Retail_Price: string;
Product_Current_Inventory: number;
}
export const filter = [
['Product_Current_Inventory', '<>', 0],
'or',
[
['Product_Name', 'contains', 'HD'],
'and',
['Product_Cost', '<', 200],
],
];
export const fields: (DxFilterBuilderTypes.Field)[] = [
{
caption: 'ID',
dataField: 'Product_ID',
dataType: 'number',
}, {
dataField: 'Product_Name',
dataType: 'string',
}, {
caption: 'Cost',
dataField: 'Product_Cost',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Sale_Price',
caption: 'Sale Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Retail_Price',
caption: 'Retail Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Current_Inventory',
dataType: 'number',
caption: 'Inventory',
},
];
export const columns: (DxDataGridTypes.Column)[] = [
{
caption: 'ID',
dataField: 'Product_ID',
dataType: 'number',
width: 50,
}, {
dataField: 'Product_Name',
dataType: 'string',
}, {
caption: 'Cost',
dataField: 'Product_Cost',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Sale_Price',
caption: 'Sale Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Retail_Price',
caption: 'Retail Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Current_Inventory',
dataType: 'number',
caption: 'Inventory',
},
];
export const products: Product[] = [
{
Product_ID: 1,
Product_Name: "HD Video Player",
Product_Cost: "110.0000",
Product_Sale_Price: "220.0000",
Product_Retail_Price: "330.0000",
Product_Current_Inventory: 225,
},
{
Product_ID: 2,
Product_Name: "SuperHD Video Player",
Product_Cost: "175.0000",
Product_Sale_Price: "275.0000",
Product_Retail_Price: "400.0000",
Product_Current_Inventory: 150,
},
{
Product_ID: 3,
Product_Name: "SuperPlasma 50",
Product_Cost: "1100.0000",
Product_Sale_Price: "1800.0000",
Product_Retail_Price: "2400.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 4,
Product_Name: "SuperLED 50",
Product_Cost: "775.0000",
Product_Sale_Price: "1100.0000",
Product_Retail_Price: "1600.0000",
Product_Current_Inventory: 77,
},
{
Product_ID: 5,
Product_Name: "SuperLED 42",
Product_Cost: "675.0000",
Product_Sale_Price: "1050.0000",
Product_Retail_Price: "1450.0000",
Product_Current_Inventory: 445,
},
{
Product_ID: 6,
Product_Name: "SuperLCD 55",
Product_Cost: "745.0000",
Product_Sale_Price: "1045.0000",
Product_Retail_Price: "1350.0000",
Product_Current_Inventory: 345,
},
{
Product_ID: 7,
Product_Name: "SuperLCD 42",
Product_Cost: "710.0000",
Product_Sale_Price: "999.0000",
Product_Retail_Price: "1200.0000",
Product_Current_Inventory: 210,
},
{
Product_ID: 8,
Product_Name: "SuperPlasma 65",
Product_Cost: "1800.0000",
Product_Sale_Price: "2900.0000",
Product_Retail_Price: "3500.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 9,
Product_Name: "SuperLCD 70",
Product_Cost: "2125.0000",
Product_Sale_Price: "3200.0000",
Product_Retail_Price: "4000.0000",
Product_Current_Inventory: 95,
},
{
Product_ID: 10,
Product_Name: "DesktopLED 21",
Product_Cost: "75.0000",
Product_Sale_Price: "125.0000",
Product_Retail_Price: "175.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 11,
Product_Name: "DesktopLED 19",
Product_Cost: "70.0000",
Product_Sale_Price: "115.0000",
Product_Retail_Price: "165.0000",
Product_Current_Inventory: 425,
},
{
Product_ID: 12,
Product_Name: "DesktopLCD 21",
Product_Cost: "75.0000",
Product_Sale_Price: "120.0000",
Product_Retail_Price: "170.0000",
Product_Current_Inventory: 210,
},
{
Product_ID: 13,
Product_Name: "DesktopLCD 19",
Product_Cost: "68.0000",
Product_Sale_Price: "110.0000",
Product_Retail_Price: "160.0000",
Product_Current_Inventory: 150,
},
{
Product_ID: 14,
Product_Name: "Projector Plus",
Product_Cost: "225.0000",
Product_Sale_Price: "400.0000",
Product_Retail_Price: "550.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 15,
Product_Name: "Projector PlusHD",
Product_Cost: "425.0000",
Product_Sale_Price: "600.0000",
Product_Retail_Price: "750.0000",
Product_Current_Inventory: 110,
},
{
Product_ID: 16,
Product_Name: "Projector PlusHT",
Product_Cost: "725.0000",
Product_Sale_Price: "900.0000",
Product_Retail_Price: "1050.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 17,
Product_Name: "ExcelRemote IR",
Product_Cost: "55.0000",
Product_Sale_Price: "105.0000",
Product_Retail_Price: "150.0000",
Product_Current_Inventory: 650,
},
{
Product_ID: 18,
Product_Name: "ExcelRemote Bluetooth",
Product_Cost: "85.0000",
Product_Sale_Price: "135.0000",
Product_Retail_Price: "180.0000",
Product_Current_Inventory: 310,
},
{
Product_ID: 19,
Product_Name: "ExcelRemote IP",
Product_Cost: "105.0000",
Product_Sale_Price: "155.0000",
Product_Retail_Price: "200.0000",
Product_Current_Inventory: 0,
},
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the FilterBuilder features used.
Backend API
import React, { useCallback, useState } from 'react';
import FilterBuilder, { type FilterBuilderTypes } from 'devextreme-react/filter-builder';
import Button from 'devextreme-react/button';
import DataGrid from 'devextreme-react/data-grid';
import { filter, fields, columns, products } from './data.ts';
const App = () => {
const [value, setValue] = useState(filter);
const [gridFilterValue, setGridFilterValue] = useState(filter);
const onValueChanged = useCallback((e: FilterBuilderTypes.ValueChangedEvent) => {
setValue(e.value);
}, []);
const buttonClick = useCallback(() => {
setGridFilterValue(value);
}, [value]);
return (
<div>
<div className="filter-container">
<FilterBuilder fields={fields} value={value} onValueChanged={onValueChanged} />
<Button text="Apply Filter" type="default" onClick={buttonClick} />
<div className="dx-clearfix"></div>
</div>
<DataGrid
dataSource={products}
filterValue={gridFilterValue}
showBorders={true}
columns={columns}
height={300}
/>
</div>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import FilterBuilder from 'devextreme-react/filter-builder';
import Button from 'devextreme-react/button';
import DataGrid from 'devextreme-react/data-grid';
import {
filter, fields, columns, products,
} from './data.js';
const App = () => {
const [value, setValue] = useState(filter);
const [gridFilterValue, setGridFilterValue] = useState(filter);
const onValueChanged = useCallback((e) => {
setValue(e.value);
}, []);
const buttonClick = useCallback(() => {
setGridFilterValue(value);
}, [value]);
return (
<div>
<div className="filter-container">
<FilterBuilder
fields={fields}
value={value}
onValueChanged={onValueChanged}
/>
<Button
text="Apply Filter"
type="default"
onClick={buttonClick}
/>
<div className="dx-clearfix"></div>
</div>
<DataGrid
dataSource={products}
filterValue={gridFilterValue}
showBorders={true}
columns={columns}
height={300}
/>
</div>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { DataType } from 'devextreme/common';
interface Product {
Product_ID: number;
Product_Name: string;
Product_Cost: string;
Product_Sale_Price: string;
Product_Retail_Price: string;
Product_Current_Inventory: number;
}
interface Field {
caption?: string,
dataField: string,
dataType: DataType,
format?: string,
}
interface Column extends Field {
width?: number,
}
export const filter = [
['Product_Current_Inventory', '<>', 0],
'or',
[
['Product_Name', 'contains', 'HD'],
'and',
['Product_Cost', '<', 200],
],
];
export const fields: Field[] = [
{
caption: 'ID',
dataField: 'Product_ID',
dataType: 'number',
}, {
dataField: 'Product_Name',
dataType: 'string',
}, {
caption: 'Cost',
dataField: 'Product_Cost',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Sale_Price',
caption: 'Sale Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Retail_Price',
caption: 'Retail Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Current_Inventory',
dataType: 'number',
caption: 'Inventory',
},
];
export const columns: Column[] = [
{
caption: 'ID',
dataField: 'Product_ID',
dataType: 'number',
width: 50,
}, {
dataField: 'Product_Name',
dataType: 'string',
}, {
caption: 'Cost',
dataField: 'Product_Cost',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Sale_Price',
caption: 'Sale Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Retail_Price',
caption: 'Retail Price',
dataType: 'number',
format: 'currency',
}, {
dataField: 'Product_Current_Inventory',
dataType: 'number',
caption: 'Inventory',
},
];
export const products: Product[] = [
{
Product_ID: 1,
Product_Name: "HD Video Player",
Product_Cost: "110.0000",
Product_Sale_Price: "220.0000",
Product_Retail_Price: "330.0000",
Product_Current_Inventory: 225,
},
{
Product_ID: 2,
Product_Name: "SuperHD Video Player",
Product_Cost: "175.0000",
Product_Sale_Price: "275.0000",
Product_Retail_Price: "400.0000",
Product_Current_Inventory: 150,
},
{
Product_ID: 3,
Product_Name: "SuperPlasma 50",
Product_Cost: "1100.0000",
Product_Sale_Price: "1800.0000",
Product_Retail_Price: "2400.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 4,
Product_Name: "SuperLED 50",
Product_Cost: "775.0000",
Product_Sale_Price: "1100.0000",
Product_Retail_Price: "1600.0000",
Product_Current_Inventory: 77,
},
{
Product_ID: 5,
Product_Name: "SuperLED 42",
Product_Cost: "675.0000",
Product_Sale_Price: "1050.0000",
Product_Retail_Price: "1450.0000",
Product_Current_Inventory: 445,
},
{
Product_ID: 6,
Product_Name: "SuperLCD 55",
Product_Cost: "745.0000",
Product_Sale_Price: "1045.0000",
Product_Retail_Price: "1350.0000",
Product_Current_Inventory: 345,
},
{
Product_ID: 7,
Product_Name: "SuperLCD 42",
Product_Cost: "710.0000",
Product_Sale_Price: "999.0000",
Product_Retail_Price: "1200.0000",
Product_Current_Inventory: 210,
},
{
Product_ID: 8,
Product_Name: "SuperPlasma 65",
Product_Cost: "1800.0000",
Product_Sale_Price: "2900.0000",
Product_Retail_Price: "3500.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 9,
Product_Name: "SuperLCD 70",
Product_Cost: "2125.0000",
Product_Sale_Price: "3200.0000",
Product_Retail_Price: "4000.0000",
Product_Current_Inventory: 95,
},
{
Product_ID: 10,
Product_Name: "DesktopLED 21",
Product_Cost: "75.0000",
Product_Sale_Price: "125.0000",
Product_Retail_Price: "175.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 11,
Product_Name: "DesktopLED 19",
Product_Cost: "70.0000",
Product_Sale_Price: "115.0000",
Product_Retail_Price: "165.0000",
Product_Current_Inventory: 425,
},
{
Product_ID: 12,
Product_Name: "DesktopLCD 21",
Product_Cost: "75.0000",
Product_Sale_Price: "120.0000",
Product_Retail_Price: "170.0000",
Product_Current_Inventory: 210,
},
{
Product_ID: 13,
Product_Name: "DesktopLCD 19",
Product_Cost: "68.0000",
Product_Sale_Price: "110.0000",
Product_Retail_Price: "160.0000",
Product_Current_Inventory: 150,
},
{
Product_ID: 14,
Product_Name: "Projector Plus",
Product_Cost: "225.0000",
Product_Sale_Price: "400.0000",
Product_Retail_Price: "550.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 15,
Product_Name: "Projector PlusHD",
Product_Cost: "425.0000",
Product_Sale_Price: "600.0000",
Product_Retail_Price: "750.0000",
Product_Current_Inventory: 110,
},
{
Product_ID: 16,
Product_Name: "Projector PlusHT",
Product_Cost: "725.0000",
Product_Sale_Price: "900.0000",
Product_Retail_Price: "1050.0000",
Product_Current_Inventory: 0,
},
{
Product_ID: 17,
Product_Name: "ExcelRemote IR",
Product_Cost: "55.0000",
Product_Sale_Price: "105.0000",
Product_Retail_Price: "150.0000",
Product_Current_Inventory: 650,
},
{
Product_ID: 18,
Product_Name: "ExcelRemote Bluetooth",
Product_Cost: "85.0000",
Product_Sale_Price: "135.0000",
Product_Retail_Price: "180.0000",
Product_Current_Inventory: 310,
},
{
Product_ID: 19,
Product_Name: "ExcelRemote IP",
Product_Cost: "105.0000",
Product_Sale_Price: "155.0000",
Product_Retail_Price: "200.0000",
Product_Current_Inventory: 0,
},
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const filter = [
['Product_Current_Inventory', '<>', 0],
'or',
[['Product_Name', 'contains', 'HD'], 'and', ['Product_Cost', '<', 200]],
];
export const fields = [
{
caption: 'ID',
dataField: 'Product_ID',
dataType: 'number',
},
{
dataField: 'Product_Name',
dataType: 'string',
},
{
caption: 'Cost',
dataField: 'Product_Cost',
dataType: 'number',
format: 'currency',
},
{
dataField: 'Product_Sale_Price',
caption: 'Sale Price',
dataType: 'number',
format: 'currency',
},
{
dataField: 'Product_Retail_Price',
caption: 'Retail Price',
dataType: 'number',
format: 'currency',
},
{
dataField: 'Product_Current_Inventory',
dataType: 'number',
caption: 'Inventory',
},
];
export const columns = [
{
caption: 'ID',
dataField: 'Product_ID',
dataType: 'number',
width: 50,
},
{
dataField: 'Product_Name',
dataType: 'string',
},
{
caption: 'Cost',
dataField: 'Product_Cost',
dataType: 'number',
format: 'currency',
},
{
dataField: 'Product_Sale_Price',
caption: 'Sale Price',
dataType: 'number',
format: 'currency',
},
{
dataField: 'Product_Retail_Price',
caption: 'Retail Price',
dataType: 'number',
format: 'currency',
},
{
dataField: 'Product_Current_Inventory',
dataType: 'number',
caption: 'Inventory',
},
];
export const products = [
{
Product_ID: 1,
Product_Name: 'HD Video Player',
Product_Cost: '110.0000',
Product_Sale_Price: '220.0000',
Product_Retail_Price: '330.0000',
Product_Current_Inventory: 225,
},
{
Product_ID: 2,
Product_Name: 'SuperHD Video Player',
Product_Cost: '175.0000',
Product_Sale_Price: '275.0000',
Product_Retail_Price: '400.0000',
Product_Current_Inventory: 150,
},
{
Product_ID: 3,
Product_Name: 'SuperPlasma 50',
Product_Cost: '1100.0000',
Product_Sale_Price: '1800.0000',
Product_Retail_Price: '2400.0000',
Product_Current_Inventory: 0,
},
{
Product_ID: 4,
Product_Name: 'SuperLED 50',
Product_Cost: '775.0000',
Product_Sale_Price: '1100.0000',
Product_Retail_Price: '1600.0000',
Product_Current_Inventory: 77,
},
{
Product_ID: 5,
Product_Name: 'SuperLED 42',
Product_Cost: '675.0000',
Product_Sale_Price: '1050.0000',
Product_Retail_Price: '1450.0000',
Product_Current_Inventory: 445,
},
{
Product_ID: 6,
Product_Name: 'SuperLCD 55',
Product_Cost: '745.0000',
Product_Sale_Price: '1045.0000',
Product_Retail_Price: '1350.0000',
Product_Current_Inventory: 345,
},
{
Product_ID: 7,
Product_Name: 'SuperLCD 42',
Product_Cost: '710.0000',
Product_Sale_Price: '999.0000',
Product_Retail_Price: '1200.0000',
Product_Current_Inventory: 210,
},
{
Product_ID: 8,
Product_Name: 'SuperPlasma 65',
Product_Cost: '1800.0000',
Product_Sale_Price: '2900.0000',
Product_Retail_Price: '3500.0000',
Product_Current_Inventory: 0,
},
{
Product_ID: 9,
Product_Name: 'SuperLCD 70',
Product_Cost: '2125.0000',
Product_Sale_Price: '3200.0000',
Product_Retail_Price: '4000.0000',
Product_Current_Inventory: 95,
},
{
Product_ID: 10,
Product_Name: 'DesktopLED 21',
Product_Cost: '75.0000',
Product_Sale_Price: '125.0000',
Product_Retail_Price: '175.0000',
Product_Current_Inventory: 0,
},
{
Product_ID: 11,
Product_Name: 'DesktopLED 19',
Product_Cost: '70.0000',
Product_Sale_Price: '115.0000',
Product_Retail_Price: '165.0000',
Product_Current_Inventory: 425,
},
{
Product_ID: 12,
Product_Name: 'DesktopLCD 21',
Product_Cost: '75.0000',
Product_Sale_Price: '120.0000',
Product_Retail_Price: '170.0000',
Product_Current_Inventory: 210,
},
{
Product_ID: 13,
Product_Name: 'DesktopLCD 19',
Product_Cost: '68.0000',
Product_Sale_Price: '110.0000',
Product_Retail_Price: '160.0000',
Product_Current_Inventory: 150,
},
{
Product_ID: 14,
Product_Name: 'Projector Plus',
Product_Cost: '225.0000',
Product_Sale_Price: '400.0000',
Product_Retail_Price: '550.0000',
Product_Current_Inventory: 0,
},
{
Product_ID: 15,
Product_Name: 'Projector PlusHD',
Product_Cost: '425.0000',
Product_Sale_Price: '600.0000',
Product_Retail_Price: '750.0000',
Product_Current_Inventory: 110,
},
{
Product_ID: 16,
Product_Name: 'Projector PlusHT',
Product_Cost: '725.0000',
Product_Sale_Price: '900.0000',
Product_Retail_Price: '1050.0000',
Product_Current_Inventory: 0,
},
{
Product_ID: 17,
Product_Name: 'ExcelRemote IR',
Product_Cost: '55.0000',
Product_Sale_Price: '105.0000',
Product_Retail_Price: '150.0000',
Product_Current_Inventory: 650,
},
{
Product_ID: 18,
Product_Name: 'ExcelRemote Bluetooth',
Product_Cost: '85.0000',
Product_Sale_Price: '135.0000',
Product_Retail_Price: '180.0000',
Product_Current_Inventory: 310,
},
{
Product_ID: 19,
Product_Name: 'ExcelRemote IP',
Product_Cost: '105.0000',
Product_Sale_Price: '155.0000',
Product_Retail_Price: '200.0000',
Product_Current_Inventory: 0,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.filter-container {
background-color: transparent;
box-shadow: 0 8px 16px 0 rgba(0, 0, 0, 0.14), 0 0 2px 0 rgba(0, 0, 0, 0.12);
border-radius: 6px;
padding: 5px;
width: 500px;
margin: 24px;
}
.dx-filterbuilder {
background-color: transparent;
padding: 10px;
}
.dx-button {
margin: 10px;
float: right;
}
.dx-filterbuilder .dx-numberbox {
width: 80px;
}